/*
 * File: ert_main.c
 *
 * Code generated with Waijung 2 ESP32 Target Blockset,
 * for Simulink model 'ESP32_test'.
 *
 * Model version                  : 1.1
 * Simulink Coder version         : 9.5 (R2021a) 14-Nov-2020
 * C/C++ source code generated on : Thu Jul 29 12:06:43 2021
 *
 * Target selection: esp32.tlc
 * Embedded hardware selection: Intel->x86-64 (Windows64)
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "ESP32_test.h"                /* Model's header file */
#include "rtwtypes.h"

/*
 *===============================================================
 * Simulink simulation information
 *===============================================================
 * Simulink model name: ESP32_test
 * Note that:
 * Waijung 2 ESP32 target forces "Higher priority value indicates
 * higher task priority" under Simulink model configuration.
 * This is opposite to the default Simulink configuration where
 * lower priority value indicates higher priority.
 * Base priority level for all synchronous (periodic) and asynchronous tasks: 0
 * (This is set from Waijung 2 ESP32 target setup blockset under FreeRTOS tab -> Base task priority parameter.)
 * Synchronous (periodic) task information:
 * Number of synchronous periodic tasks: 2
 * Highest priority level needed for periodic tasks: 1
 * Highest priority level limit for the system: 16
 * Task 0 (Function name: vTaskFunctionBaseRate), base rate: 1.0E-6 seconds, priority: 1
 * Task 1 (Function name: vTaskFunctionSubRate_1), rate: 1.0 seconds, priority:  0
 * Default NULL definition: (NULL)
 *
 *===============================================================
 * Waijung 2 Info
 *===============================================================
 * Waijung 2 version: 20.11b
 * Waijung 2 target: ESP32
 * Target OS: FreeRTOS
 * Project path: E:\HAM\ESP32_Test\ESP32_test_esp32_build_system
 * Toolchain: ESP-IDF
 * ESP-IDF path: C:\msys32\home\skris\esp\esp-idf
 *===============================================================
 */

/* ANSI C headers */
#include <float.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/* Waijung 2 headers */
#include "waijung2_hwdrvlib.h"

/* Default xTaskCreate stack size */
#ifndef DEFAULT_STACK_SIZE
#define DEFAULT_STACK_SIZE             8192
#endif

void vTaskFunctionSubRate_1(void *pvParameters)
{
  const TickType_t vPeriodicTaskPreiod = 1000/portTICK_PERIOD_MS;
  TickType_t xLastWakeTime;
  xLastWakeTime = xTaskGetTickCount();
  while (1) {
    vTaskDelayUntil(&xLastWakeTime, vPeriodicTaskPreiod);

    /* Multitasking vTask for FreeRTOS */
    ESP32_test_step1();

    /* Get model outputs here */
  }
}

void vTaskFunctionBaseRate(void *pvParameters)
{
  const TickType_t vPeriodicTaskPreiod = 0/portTICK_PERIOD_MS;
  TickType_t xLastWakeTime;
  xLastWakeTime = xTaskGetTickCount();

  /* For debuging the base rate semaphore release. Ignore */
  while (1) {
    /* Set model base rate here: */
    vTaskDelayUntil(&xLastWakeTime, vPeriodicTaskPreiod);

    /* Release the Semaphores for all the base rate functions here: */
    ESP32_test_step0();

    /* Get model outputs here */
  }
}

/*
 * Spawn ESP32_test_main as an independent FreeRTOS task
 * from your application code.
 */
void app_main(void)
{
  /* Initialize model */
  ESP32_test_initialize();

  /*
   * base_priority variable is used for assigning periodic task priority.
   * Note that, for periodic tasks, Priority property in Simulink blocks
   * has no effects on task execution order. Fastest rate blocks (smaller
   * block's sample time) always have higher priority.
   */
  UBaseType_t base_priority = 0;       /* Base priority */
  xTaskCreate(vTaskFunctionBaseRate, "vTaskFunctionBaseRate", DEFAULT_STACK_SIZE,
              NULL, base_priority + 1, NULL);
  xTaskCreate(vTaskFunctionSubRate_1, "vTaskFunctionSubRate_1",
              DEFAULT_STACK_SIZE, NULL, base_priority + 0, NULL);
}

/* [EOF] */
