/*
 * File: waijung2_hwdrvlib.c
 *
 * Code generated with Waijung 2 ESP32 Target Blockset,
 * for Simulink model 'ESP32_test'.
 *
 * Model version                  : 1.1
 * Simulink Coder version         : 9.5 (R2021a) 14-Nov-2020
 * C/C++ source code generated on : Thu Jul 29 12:06:43 2021
 *
 * Target selection: esp32.tlc
 * Embedded hardware selection: Intel->x86-64 (Windows64)
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "ESP32_test.h"                /* Model's header file */

void uart_init(uint32_t buadrate, uart_word_length_t databits, uart_parity_t
               parity, uart_stop_bits_t stopbit, uart_hw_flowcontrol_t
               flowcontrol,uart_port_t uartport, int8_t txpin, int8_t rxpin,
               int8_t rtspin, int8_t ctspin, uint16_t rxbuf, uint16_t txbuf )
{
  uart_config_t uart_config = {
    .baud_rate = buadrate,
    .data_bits = databits,
    .parity = parity,
    .stop_bits = stopbit,
    .flow_ctrl = flowcontrol
  };

  uart_param_config(uartport, &uart_config);
  uart_set_pin(uartport, txpin, rxpin, rtspin, ctspin);
  uart_driver_install(uartport, rxbuf, txbuf, 0, NULL, 0);
}

/* ########################################################################
 * Name: <Root>/UART Tx
 * Id: UARTTx
 * ########################################################################
 */
/* Binary header */
const char UARTTx_Header[UARTTx_Header_SIZE] = { 0x7E, 0x7E };

/* Binary terminator */
const char UARTTx_Terminator[UARTTx_Terminator_SIZE] = { 0x3, 0x3 };

void enable_UARTTx(void)
{
}

void disable_UARTTx(void)
{
}

/* ########################################################################
 * Name: <Root>/UART Setup
 * Id: UARTSetup
 * ########################################################################
 */
uint8_t UART0_Tx_Buffer[UTX0_BUFFER_SIZE];
volatile uint8_t UART0_Rx_Buffer[URX0_BUFFER_SIZE];
uint8_t UART0_Temp_Buffer[URX0_BUFFER_SIZE];

//volatile uint16_t UART0_Rx_Index = 0;
volatile uint16_t UART0_Rx_Count = 0;

//volatile uint16_t UART0_Rx_Count = 0;
volatile uint8_t UART0_Tx_Done = 0;
void UART0_RestoreBytes(UARTRX_BUFFER_READ_STRUCT *read_struct, uint16_t count)
{
  uint16_t roll_count = count;

  /* Remove overflow buffer */
  while (roll_count > URX0_BUFFER_SIZE)
    roll_count -= URX0_BUFFER_SIZE;

  /* Return bytes back into buffer */
  if (roll_count > read_struct->index)
    read_struct->index = URX0_BUFFER_SIZE - roll_count + read_struct->index;
  else
    read_struct->index -= roll_count;
}

/* Read buffer from DMA
 ** Return value: Number of bytes vaiable.
 */
void UART0_Read(UARTRX_BUFFER_READ_STRUCT *read_struct)
{
  volatile uint16_t data_int_curr_count;
  uint16_t data_index = 0;
  uint16_t data_count = 0;

  /* Current data received count of Rx-buffer */
  data_int_curr_count = UART0_Rx_Count;

  /* Read single part of data buffer */
  if (read_struct->index < data_int_curr_count) {/* Data is available */
    data_index = read_struct->index;
    data_count = data_int_curr_count - read_struct->index;
    read_struct->index += data_count;
    read_struct->index &= (URX0_BUFFER_SIZE-1);
  } else if (read_struct->index > data_int_curr_count) {/* Data is available with overlap */
    data_index = read_struct->index;
    data_count = URX0_BUFFER_SIZE-read_struct->index;
    read_struct->index = 0;
  } else {                             /* No new data */
  }

  /* Return the reading */
  if (data_count > 0) {
    read_struct->buffer = (uint8_t *)&UART0_Rx_Buffer[data_index];
    read_struct->count = data_count;
  } else {
    read_struct->count = 0;
  }
}

void UART0_ReadEx(UARTRX_BUFFER_READ_STRUCT *read_struct, uint8_t *buffer,
                  uint16_t buffer_size, uint16_t*reading_count)
{
  uint16_t bytes_to_read, data_read_index;
  bytes_to_read = buffer_size;         /* Tracking count of data readings */
  data_read_index = 0;                 /* Increment buffer index */
  do {
    UART0_Read(read_struct);
    if (read_struct->count <= bytes_to_read) {
      memcpy(&buffer[data_read_index], read_struct->buffer, read_struct->count);
      data_read_index += read_struct->count;
      bytes_to_read -= read_struct->count;
    } else {
      /* Return some byte back to buffer */
      //read_struct->index -= (read_struct->count - bytes_to_read);
      UART0_RestoreBytes(read_struct, (read_struct->count - bytes_to_read));/* Fixed: Waijung 14.08a */

      /* Return reading data */
      memcpy(&buffer[data_read_index], read_struct->buffer, bytes_to_read);
      bytes_to_read = 0;
    }
  } while ((bytes_to_read > 0) && (read_struct->count > 0));

  /* Number of reading bytes */
  *reading_count = buffer_size - bytes_to_read;
}

/* Read Ascii packet
 * Return char count, exclude NULL
 * Terminator: "\n", "\r", "\r\n"
 */
uint16_t UART0_ReadLine(UARTRX_BUFFER_READ_STRUCT *read_struct, const char
  *terminator, uint16_t terminator_count, uint8_t *buffer, uint16_t buffer_size)
{
  while (1) {
    uint8_t data;
    int num_read = uart_read_bytes(UART_NUM_0, (&data), 1, 0);//timeout 0 no waiting
    if (num_read > 0) {
      UART0_Rx_Buffer[UART0_Rx_Count++] = data;
      UART0_Rx_Count &= (URX0_BUFFER_SIZE-1);
    } else {                           //uart read returned zero bytes
      break;
    }
  }

  uint16_t count, packet_len = 0, receive_count = 0;
  uint16_t i;
  uint8_t terminator_found = 0;

  /* Determine maximum number of bytes to read */
  count = buffer_size - 1;
  if (count >= URX0_BUFFER_SIZE)
    count = URX0_BUFFER_SIZE-1;

  /* Ignore terminator is invalid */
  if (terminator_count < 1)
    return 0;

  /* Read packet */
  do {
    UART0_Read(read_struct);           /* Check DMA buffer */
    receive_count += read_struct->count;/* Total number of data received */

    /* Search terminator */
    i = 0;
    while (!terminator_found && (i < read_struct->count)) {
      if (read_struct->buffer[i] == (uint8_t)terminator[terminator_count - 1])
        terminator_found = 1;
      i++;
    }

    packet_len += i;
    if (terminator_found) {
      terminator_found = 0;

      /* Roll-back buffer index */
      if ((packet_len > count) || (packet_len < terminator_count)) {/* Packet count is invalid, drop it */
        UART0_RestoreBytes(read_struct, (receive_count-packet_len));

        /* Reset */
        packet_len = 0;
        receive_count = 0;
      } else {
        UART0_RestoreBytes(read_struct, receive_count);

        /* Load data into buffer */
        UART0_ReadEx(read_struct, buffer, packet_len, &i);
        buffer[packet_len] = '\0';     /* Append NULL */

        /* Validate terminator */
        if (!strncmp((char *)&buffer[packet_len-terminator_count], terminator,
                     terminator_count)) {
          return packet_len;
                   /* packet reading success, return number of received bytes */
        } else {
          /* Invalid terminator */
          packet_len = 0;
          receive_count = 0;
        }
      }
    }
  } while (read_struct->count > 0);

  /* Could not find the packet terminator, reset reading struct to its original position */
  if (receive_count > 0) {
    UART0_RestoreBytes(read_struct, receive_count);
  }

  /* No byte receive */
  return 0;
}

/* Read Binary packet
 * 0: Not ready, 1: Data is ready
 */
uint8_t UART0_ReadBinary(UARTRX_BUFFER_READ_STRUCT *read_struct, const char
  *header, uint16_t header_count, const char *terminator, uint16_t
  terminator_count, uint8_t *buffer, uint16_t data_count)
{
  while (1) {
    uint8_t data;
    int num_read = uart_read_bytes(UART_NUM_0, (&data), 1, 0);//timeout 0 no waiting
    if (num_read > 0) {
      UART0_Rx_Buffer[UART0_Rx_Count++] = data;
      UART0_Rx_Count &= (URX0_BUFFER_SIZE-1);
    } else {                           //uart read returned zero bytes
      break;
    }
  }

  uint16_t receive_count = 0, drop_count = 0, binary_state = 0, binary_index = 0;
  uint16_t i;
  do {
    UART0_Read(read_struct);           /* Check DMA buffer */
    receive_count += read_struct->count;/* Total number of data received */

    /* Binary packet processing */
    for (i=0; i<read_struct->count; i++) {
      switch ( binary_state ) {
        // fall through
       case 0:
        /* Search for header */
        if (binary_index < header_count) {
          if (read_struct->buffer[i] == header[binary_index]) {
            binary_index ++;
          } else {
            binary_index = 0;
            drop_count = receive_count - (read_struct->count - i - 1);/* Drop packet */
          }
          break;
        } else {                       /* Change to DATA state */
          binary_index = 0;
          binary_state ++;
        }

        // fall through
       case 1:
        /* Wait for DATA */
        if (binary_index < data_count) {
          buffer[binary_index] = read_struct->buffer[i];
          binary_index ++;

          /* Check if ready (No terminator) */
          if ((binary_index >= data_count) && (terminator_count == 0)) {
            UART0_RestoreBytes(read_struct, (read_struct->count - i - 1));/* Restore some bytes */
            return 1;                  /* Return success status */
          }
          break;
        } else {                       /* Change to Terminator state */
          binary_index = 0;
          binary_state ++;
        }

        // fall through
       case 2:
        /* Scan for terminator */
        if (binary_index < terminator_count) {
          if (read_struct->buffer[i] == terminator[binary_index]) {
            binary_index ++;
          } else {
            binary_state = 0;
            binary_index = 0;
            drop_count = receive_count - (read_struct->count - i - 1);/* Drop packet */
          }
        }

        if (binary_index >= terminator_count) {/* Success */
          /* Restore some bytes */
          UART0_RestoreBytes(read_struct, (read_struct->count - i - 1));
          return 1;                    /* Return success status */
        }
        break;
      }
    }
  } while (read_struct->count > 0);

  /* Restore bytes */
  UART0_RestoreBytes(read_struct, (receive_count - drop_count));
  return 0;
}

void UART0_Write(uart_port_t uart_controller, const uint8_t *data, uint16_t
                 count)
{
  uart_write_bytes(uart_controller, (char *)data, count);
}

void enable_UARTSetup(void)
{
  //initialise uart
  uart_init(9600,UART_DATA_6_BITS, UART_PARITY_DISABLE,UART_STOP_BITS_1,
            UART_HW_FLOWCTRL_DISABLE,UART_NUM_0,32, 33, -1, -1, 256, 256 );

  // Reset Read index
  UART0_Rx_Count = 0;
}

void disable_UARTSetup(void)
{
  uart_driver_delete(UART_NUM_0);
}

/* [EOF] */
