/*
 * File: waijung2_hwdrvlib.h
 *
 * Code generated with Waijung 2 ESP32 Target Blockset,
 * for Simulink model 'ESP32_test'.
 *
 * Model version                  : 1.1
 * Simulink Coder version         : 9.5 (R2021a) 14-Nov-2020
 * C/C++ source code generated on : Thu Jul 29 12:06:43 2021
 *
 * Target selection: esp32.tlc
 * Embedded hardware selection: Intel->x86-64 (Windows64)
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_waijung2_hwdrvlib_h_
#define RTW_HEADER_waijung2_hwdrvlib_h_

/* ESP32 headers */
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "esp_system.h"
#include "esp_spi_flash.h"
#include "soc/timer_group_struct.h"
#include "soc/timer_group_reg.h"
#include "freertos/semphr.h"
#include "esp_err.h"
#include "esp_log.h"
#include <stdio.h>
#include <stdint.h>
#include <stddef.h>
#include <string.h>
#include "driver/uart.h"

void uart_init(uint32_t buadrate, uart_word_length_t databits, uart_parity_t
               parity, uart_stop_bits_t stopbit, uart_hw_flowcontrol_t
               flowcontrol,uart_port_t uartport, int8_t txpin, int8_t rxpin,
               int8_t rtspin, int8_t ctspin, uint16_t rxbuf, uint16_t txbuf );

/* ########################################################################
 * Name: UART
 * ########################################################################
 */
/* Data read structure */
typedef struct {
  uint16_t index;                      /* Index of data in buffer */
  uint16_t count;                      /* Return data count */
  uint8_t *buffer;                     /* Return buffer pointer of valid data */
} UARTRX_BUFFER_READ_STRUCT;

#define BASE_SAMPLE_TIME               1.0E-6                    /* Base sample time in second */

/* ########################################################################
 * Name: <Root>/UART Tx
 * Id: UARTTx
 * ########################################################################
 */
/* Binary header */
#define UARTTx_Header_SIZE             2

extern const char UARTTx_Header[UARTTx_Header_SIZE];

/* Binary terminator */
#define UARTTx_Terminator_SIZE         2

extern const char UARTTx_Terminator[UARTTx_Terminator_SIZE];
void enable_UARTTx(void);
void disable_UARTTx(void);

/* ########################################################################
 * Name: <Root>/UART Setup
 * Id: UARTSetup
 * ########################################################################
 */
//  /* Data read structure */
//  typedef struct {
//    uint16_t index; /* Index of data in buffer */
//    uint16_t count; /* Return data count */
//    uint8_t *buffer; /* Return buffer pointer of valid data */
//  } UARTRX_BUFFER_READ_STRUCT;
#define URX0_BUFFER_SIZE               256                       /* Must be 2^N ;N=4,5,6,... */
#define UTX0_BUFFER_SIZE               256                       /* Must be 2^N ;N=4,5,6,... */
#define UART0_HW_FLOW                  1
#define UART0_TX_PIN                   32
#define UART0_RX_PIN                   33
#define UART0_CTS_PIN                  -1
#define UART0_RTS_PIN                  -1
#define UART0_BAUDRATE                 9600

extern uint8_t UART0_Tx_Buffer[UTX0_BUFFER_SIZE];
extern volatile uint8_t UART0_Rx_Buffer[URX0_BUFFER_SIZE];
extern uint8_t UART0_Temp_Buffer[URX0_BUFFER_SIZE];
uint16_t UART0_ReadLine(UARTRX_BUFFER_READ_STRUCT *read_struct, const char
  *terminator, uint16_t terminator_count, uint8_t *buffer, uint16_t buffer_size);
uint8_t UART0_ReadBinary(UARTRX_BUFFER_READ_STRUCT *read_struct, const char
  *header, uint16_t header_count, const char *terminator, uint16_t
  terminator_count, uint8_t *buffer, uint16_t data_count);
void UART0_Write(uart_port_t uart_controller, const uint8_t *data, uint16_t
                 count);
void enable_UARTSetup(void);
void disable_UARTSetup(void);

#endif                                 /* RTW_HEADER_waijung2_hwdrvlib_h_ */

/* [EOF] */
